;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


;Memory address equates

mathAreaStart EQU appBackUpScreen	;word, stores the address of the first free byte to use
mathAreaEnd EQU mathAreaStart+2		;word, stores the address of the last free byte to use

areaFreeStart EQU mathAreaEnd+2		;word, this is the first byte of free space available
areaFreeEnd EQU areaFreeStart+2		;word, this is the last byte of free space available

tempN0 EQU areaFreeEnd+2			;for modular exponentation only
tempN1 EQU tempN0+2
tempN2 EQU tempN1+2
tempN3 EQU tempN2+2
tempN4 EQU tempN3+2
tempN5 EQU tempN4+2
tempN6 EQU tempN5+2
tempN7 EQU tempN6+2
tempN8 EQU tempN7+2
tempN9 EQU tempN8+2
tempN10 EQU tempN9+2
tempN11 EQU tempN10+2
tempN12 EQU tempN11+2
tempN13 EQU tempN12+2
tempN14 EQU tempN13+2
tempN15 EQU tempN14+2
tempN16 EQU tempN15+2
tempN17 EQU tempN16+2
tempN18 EQU tempN17+2


temp1 EQU tempN18+2				;word, temporary usage
temp2 EQU temp1+2						;word, temporary usage
temp3 EQU temp2+2						;word, temporary usage
temp4 EQU temp3+2						;word, temporary usage
temp5 EQU temp4+2						;word, temporary usage
temp6 EQU temp5+2						;word, temporary usage
temp7 EQU temp6+2						;word, temporary usage

temp8 EQU temp7+2						;word, temporary usage
temp9 EQU temp8+2						;word, temporary usage
temp10 EQU temp9+2					;word, temporary usage
temp11 EQU temp10+2					;word, temporary usage
temp12 EQU temp11+2					;word, temporary usage
temp0 EQU temp12+2					;word, temporary usage --- for low-level routines (+,-)
temp13 EQU temp0+2					;word, temporary usage
temp14 EQU temp13+2					;word, temporary usage
temp15 EQU temp14+2					;word, temporary usage
temp16 EQU temp15+2					;word, temporary usage
temp17 EQU temp16+2					;word, temporary usage
temp18 EQU temp17+2					;word, temporary usage
temp19 EQU temp18+2					;word, temporary usage
temp20 EQU temp19+2					;word, temporary usage

errorStack EQU temp20+2				;word, stack value for errors
errorPointer EQU errorStack+2		;word, location to jump to for errors
errorkeycode EQU errorPointer+2	;byte, temporary key code storage during an error

;Display equates
displayOffset EQU errorkeycode+1		;word, the number of digits from the start to start displaying
displayLastByte EQU displayOffset+2	;word, this points to the last byte of the number
displayPointer EQU displayLastByte+2	;word, points to the number to display
displayFlags EQU displayPointer+2		;byte, reserved for internal flag usage
displayStart EQU displayFlags+1			;word, the starting offset of the number

;RPN stack equates
rpnNextEntry EQU displayStart+2		;word, points to the next entry in the RPN stack
rpnEntryCount EQU rpnNextEntry+2			;byte...the number of entries on the stack

maxStackEntries EQU 50			;How many entries can be on the stack?

;Entry equates
inputStart EQU rpnEntryCount+1			;word, first byte of user input
inputLen EQU inputStart+2					;word, length of user input
inputMax EQU inputLen+2					;word, maximum length of user input allowed
inputCur EQU inputMax+2					;word, next byte of user input...

;Temporary variable equates
workingspace EQU inputCur+2			;9 bytes - the name of the temporary variable created

;RPN stack equates
rpnStackStart EQU statvars				;the start of the stack

;Error codes
eArguments EQU 0
eMemory EQU 1
eBreak EQU 2
eParse EQU 3
eDivZero EQU 4
eDomain EQU 5
eStackCount EQU 6

;Flag bits
flagDebug EQU 0
flagModular	EQU 1
flagInputActive EQU 2
flagError EQU 3
flagScientific EQU 4

;Temporary splash screen

interruptCount EQU appBackUpScreen
splashPointer EQU appBackUpScreen+1
splashLeft EQU appBackUpScreen+2

;Extra functions menu - this is never at the same time as an executing math routine, thus:

currentMenu EQU temp1			;the current menu (NUM, PROB, et cetera)
maxMenu EQU currentMenu+1		;the last menu
currentItem	EQU maxMenu+1		;currently selected menu item
lastItem	EQU currentItem+1		;the last item
backupcursor EQU lastItem+1	;word, backup of (currow)
menupointer EQU backupcursor+2	;pointer to menu structure

;Games equates...they can use the temp space

numGames EQU tempN0			;byte
curGame EQU numGames+1		;byte

;Bagels equates

digit1 EQU curGame+1			;byte
digit2 EQU digit1+1			;byte
digit3 EQU digit2+1			;byte
numGuesses EQU digit3+1		;byte
guessLen EQU numGuesses+1	;byte
guess EQU guessLen+1			;3 bytes
