;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;Splash screen
SplashScreen:
	;Appvar....we only want to display the splash screen if we haven't before
	ld hl,Splash_AppVar
	rst 20h
	B_CALL ChkFindSym
	jp nc,Interface_Load
	;Create the appvar
	ld hl,17
	B_CALL EnoughMem
	jr c,SplashScreen_NoAppVar
	ld hl,10
	B_CALL CreateAppVar
	inc de
	inc de
	xor a
	ld (de),a
SplashScreen_NoAppVar:
	set textWrite,(iy+sgrflags)
	set graphDraw,(iy+graphFlags)
	B_CALL GrBufClr
	B_CALL ClrLCDFull
	ld hl,Splash_Cabamap
	ld de,plotsscreen+24
	ld bc,12*18
	ldir
	ld hl,Splash_Strings
	ld b,4
Splash_DisplayStrings:
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (pencol),de
	call vputstr
	djnz Splash_DisplayStrings
	B_CALL GrBufCpy
	B_CALL GetKey
	cp 40h
	jp z,App_Exit
	res textWrite,(iy+sgrflags)
DummyReturn:
	ret
Splash_Strings:
	DB 26,23,"Version  1.02",0
	DB 21,36,"Programmed  By",0
	DB 22,43,"Michael  Vincent",0
	DB 16,56,"Detached  Solutions",0
Splash_Cabamap:
	DB 0,8,0,2,0,0,0,0,0,0,0,0
	DB 0,24,4,3,0,8,1,2,0,64,48,0
	DB 0,56,12,3,128,12,1,134,0,96,56,0
	DB 0,56,14,3,224,28,3,134,0,224,60,0
	DB 0,112,14,3,240,28,3,207,0,224,63,0
	DB 0,240,30,3,120,30,3,207,0,240,63,128
	DB 1,224,31,3,120,62,3,255,1,240,51,192
	DB 1,192,63,3,112,62,3,255,1,240,51,128
	DB 3,128,63,3,224,118,7,123,3,176,55,128
	DB 1,192,59,131,240,119,7,123,131,184,55,0
	DB 1,224,115,131,120,119,7,51,131,184,54,0
	DB 0,224,123,131,56,227,7,51,135,24,52,0
	DB 0,112,125,131,120,251,134,1,135,220,48,0
	DB 0,120,255,195,240,255,134,1,135,252,48,0
	DB 0,56,239,195,225,223,142,1,206,252,48,0
	DB 0,24,195,195,193,199,142,1,206,60,48,0
	DB 0,24,0,227,0,1,198,1,128,14,48,0
	DB 0,0,0,0,0,0,64,0,0,2,0,0
Splash_AppVar:
	DB AppVarObj,"Cabamap",0
Interface_Load:
	;Loads an external interface if present
	ld a,b
	or a
	jr z,Interface_Load_FromRAM
	ld hl,13h
	add hl,de
	ld de,appbackupscreen
	push de
	ld bc,768
	B_CALL FlashToRam
	jr Interface_Check
Interface_Load_FromRAM:
	ex de,hl
	inc hl
	inc hl
	ld de,appbackupscreen
	push de
	ld bc,768
	ldir
Interface_Check:
	ld a,(appbackupscreen)
	ld h,0
	ld l,a
	ld d,h
	ld e,l
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	pop de
	scf
	adc hl,de
	rst 20h
	B_CALL ChkFindSym
	ret c		;Forget it - we can't find the interface
	;Now execute
	ld a,b
	or a
	jr z,Interface_Execute_RAM
	ex de,hl
	ld de,9
	call AddBHL_DE
	B_CALL LoadCIndPaged
	call Inc_BHL
	ld e,c
	call AddBHL_DE
	B_CALL LoadDEIndPaged
	call Inc_BHL
	call Inc_BHL
	call Inc_BHL
	dec de
	dec de
	ld a,b	;A - ROM page
	ld b,d
	ld c,e
	push hl
	push bc
	B_CALL MemChk
	pop bc
	or a
	sbc hl,bc
	jp c,App_Exit ;not enough memory
	pop hl
	ld de,usermem
	push bc
	push af
	push hl
	ld h,b
	ld l,c
	B_CALL InsertMem
	pop hl
	pop af
	pop bc
	push bc
	B_CALL FlashToRam
	call usermem
	pop de
	ld hl,usermem
	B_CALL DelMem
	jp App_Exit
AddBHL_DE:
	add hl,de
	bit 7,h
	ret z
	inc b
	res 7,h
	set 6,h
	ret
Inc_BHL:
	inc hl
	bit 7,h
	ret z
	inc b
	res 7,h
	set 6,h
	ret
Interface_Execute_RAM:
	B_CALL ExecutePrgm
	jp App_Exit
